## API Report File for "@microsoft/adaptive-ui"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import { CSSDesignToken } from '@microsoft/fast-foundation';
import { CSSDirective } from '@microsoft/fast-element';
import { DesignToken } from '@microsoft/fast-foundation';
import { DesignTokenResolver } from '@microsoft/fast-foundation';
import { Direction } from '@microsoft/fast-web-utilities';

// @public (undocumented)
export const accentBaseColor: CSSDesignToken<string>;

// @public (undocumented)
export const accentBaseSwatch: DesignToken<Swatch>;

// @public (undocumented)
export const accentFillActive: CSSDesignToken<Swatch>;

// @public (undocumented)
export const accentFillActiveDelta: DesignToken<number>;

// @public (undocumented)
export const accentFillFocus: CSSDesignToken<Swatch>;

// @public (undocumented)
export const accentFillFocusDelta: DesignToken<number>;

// @public (undocumented)
export const accentFillHover: CSSDesignToken<Swatch>;

// @public (undocumented)
export const accentFillHoverDelta: DesignToken<number>;

// @public (undocumented)
export const accentFillMinContrast: DesignToken<number>;

// @public (undocumented)
export const accentFillRecipe: DesignToken<InteractiveColorRecipe>;

// @public (undocumented)
export const accentFillRest: CSSDesignToken<Swatch>;

// @public (undocumented)
export const accentFillRestDelta: DesignToken<number>;

// @public (undocumented)
export const accentForegroundActive: CSSDesignToken<Swatch>;

// @public (undocumented)
export const accentForegroundActiveDelta: DesignToken<number>;

// @public (undocumented)
export const accentForegroundFocus: CSSDesignToken<Swatch>;

// @public (undocumented)
export const accentForegroundFocusDelta: DesignToken<number>;

// @public (undocumented)
export const accentForegroundHover: CSSDesignToken<Swatch>;

// @public (undocumented)
export const accentForegroundHoverDelta: DesignToken<number>;

// @public (undocumented)
export const accentForegroundMinContrast: DesignToken<number>;

// @public (undocumented)
export const accentForegroundRecipe: DesignToken<InteractiveColorRecipe>;

// @public (undocumented)
export const accentForegroundRest: CSSDesignToken<Swatch>;

// @public (undocumented)
export const accentForegroundRestDelta: DesignToken<number>;

// @public (undocumented)
export const accentPalette: DesignToken<Palette<Swatch>>;

// @public
export class BasePalette<T extends Swatch> implements Palette<T> {
    constructor(source: T, swatches: ReadonlyArray<T>);
    readonly closestIndexCache: Map<number, number>;
    closestIndexOf(reference: RelativeLuminance): number;
    colorContrast(reference: RelativeLuminance, contrastTarget: number, initialSearchIndex?: number, direction?: PaletteDirection): T;
    delta(reference: RelativeLuminance, delta: number, direction: PaletteDirection): T;
    get(index: number): T;
    readonly lastIndex: number;
    readonly reversedSwatches: ReadonlyArray<T>;
    readonly source: T;
    readonly swatches: ReadonlyArray<T>;
}

// @internal
export const _black: SwatchRGB;

// @public
export function blackOrWhiteByContrast(reference: Swatch, minContrast: number, defaultBlack: boolean): Swatch;

// @public
export function blackOrWhiteByContrastSet(restReference: Swatch, hoverReference: Swatch, activeReference: Swatch, focusReference: Swatch, minContrast: number, defaultBlack: boolean): {
    rest: Swatch;
    hover: Swatch;
    active: Swatch;
    focus: Swatch;
};

// @public (undocumented)
export const bodyFont: CSSDesignToken<string>;

// @public
export interface ColorRecipe {
    evaluate(resolver: DesignTokenResolver, reference?: Swatch): Swatch;
}

// @public
export function contrast(a: RelativeLuminance, b: RelativeLuminance): number;

// @public
export function contrastAndDeltaSwatchSet(palette: Palette, reference: Swatch, minContrast: number, restDelta: number, hoverDelta: number, activeDelta: number, focusDelta: number, direction?: PaletteDirection): InteractiveSwatchSet;

// @public
export function contrastSwatch(palette: Palette, reference: Swatch, minContrast: number, direction?: PaletteDirection): Swatch;

// @public
export const ContrastTarget: Readonly<{
    readonly NormalText: 4.5;
    readonly LargeText: 3;
}>;

// @public (undocumented)
export const controlCornerRadius: CSSDesignToken<number>;

// @public
export function deltaSwatch(palette: Palette, reference: Swatch, delta: number, direction?: PaletteDirection): Swatch;

// @public
export function deltaSwatchSet(palette: Palette, reference: Swatch, restDelta: number, hoverDelta: number, activeDelta: number, focusDelta: number, direction?: PaletteDirection): InteractiveSwatchSet;

// @public (undocumented)
export const designUnit: CSSDesignToken<number>;

// @public (undocumented)
export const direction: CSSDesignToken<Direction>;

// @public
export function directionByIsDark(color: RelativeLuminance): PaletteDirectionValue;

// @public (undocumented)
export const elevationCardActive: CSSDesignToken<string>;

// @public (undocumented)
export const elevationCardActiveSize: DesignToken<number>;

// @public (undocumented)
export const elevationCardFocus: CSSDesignToken<string>;

// @public (undocumented)
export const elevationCardFocusSize: DesignToken<number>;

// @public (undocumented)
export const elevationCardHover: CSSDesignToken<string>;

// @public (undocumented)
export const elevationCardHoverSize: DesignToken<number>;

// @public (undocumented)
export const elevationCardRest: CSSDesignToken<string>;

// @public (undocumented)
export const elevationCardRestSize: DesignToken<number>;

// @public (undocumented)
export const elevationDialog: CSSDesignToken<string>;

// @public (undocumented)
export const elevationDialogSize: DesignToken<number>;

// @public (undocumented)
export const elevationFlyout: CSSDesignToken<string>;

// @public (undocumented)
export const elevationFlyoutSize: DesignToken<number>;

// @public
export interface ElevationRecipe {
    evaluate(resolver: DesignTokenResolver, size: number): string;
}

// @public (undocumented)
export const elevationRecipe: DesignToken<ElevationRecipe>;

// @public (undocumented)
export const elevationTooltip: CSSDesignToken<string>;

// @public (undocumented)
export const elevationTooltipSize: DesignToken<number>;

// @public (undocumented)
export const fillColor: CSSDesignToken<Swatch>;

// @public (undocumented)
export const focusStrokeInner: CSSDesignToken<Swatch>;

// @public (undocumented)
export const focusStrokeInnerRecipe: DesignToken<ColorRecipe>;

// @public (undocumented)
export const focusStrokeOuter: CSSDesignToken<Swatch>;

// @public (undocumented)
export const focusStrokeOuterRecipe: DesignToken<ColorRecipe>;

// @public (undocumented)
export const focusStrokeWidth: CSSDesignToken<number>;

// @public (undocumented)
export const fontWeight: CSSDesignToken<number>;

// @public (undocumented)
export const foregroundOnAccentActive: CSSDesignToken<Swatch>;

// @public (undocumented)
export const foregroundOnAccentFocus: CSSDesignToken<Swatch>;

// @public (undocumented)
export const foregroundOnAccentHover: CSSDesignToken<Swatch>;

// @public (undocumented)
export const foregroundOnAccentRecipe: DesignToken<InteractiveColorRecipe>;

// @public (undocumented)
export const foregroundOnAccentRest: CSSDesignToken<Swatch>;

// @public
export function idealColorDeltaSwatchSet(palette: Palette, reference: Swatch, minContrast: number, idealColor: Swatch, restDelta: number, hoverDelta: number, activeDelta: number, focusDelta: number, direction?: PaletteDirection): InteractiveSwatchSet;

// @public
export interface InteractiveColorRecipe {
    evaluate(resolver: DesignTokenResolver, reference?: Swatch): InteractiveSwatchSet;
}

// @public
export interface InteractiveSwatchSet {
    active: Swatch;
    focus: Swatch;
    hover: Swatch;
    rest: Swatch;
}

// @public
export function isDark(color: RelativeLuminance): boolean;

// @public (undocumented)
export const layerCornerRadius: CSSDesignToken<number>;

// @public
export function luminanceSwatch(luminance: number): Swatch;

// @public (undocumented)
export const neutralBaseColor: CSSDesignToken<string>;

// @public (undocumented)
export const neutralBaseSwatch: DesignToken<Swatch>;

// @public (undocumented)
export const neutralFillActive: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralFillActiveDelta: DesignToken<number>;

// @public (undocumented)
export const neutralFillFocus: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralFillFocusDelta: DesignToken<number>;

// @public (undocumented)
export const neutralFillHover: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralFillHoverDelta: DesignToken<number>;

// @public (undocumented)
export const neutralFillInputActive: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralFillInputActiveDelta: DesignToken<number>;

// @public (undocumented)
export const neutralFillInputFocus: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralFillInputFocusDelta: DesignToken<number>;

// @public (undocumented)
export const neutralFillInputHover: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralFillInputHoverDelta: DesignToken<number>;

// @public (undocumented)
export const neutralFillInputRecipe: DesignToken<InteractiveColorRecipe>;

// @public (undocumented)
export const neutralFillInputRest: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralFillInputRestDelta: DesignToken<number>;

// @public (undocumented)
export const neutralFillRecipe: DesignToken<InteractiveColorRecipe>;

// @public (undocumented)
export const neutralFillRest: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralFillRestDelta: DesignToken<number>;

// @public (undocumented)
export const neutralFillSecondaryActive: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralFillSecondaryActiveDelta: DesignToken<number>;

// @public (undocumented)
export const neutralFillSecondaryFocus: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralFillSecondaryFocusDelta: DesignToken<number>;

// @public (undocumented)
export const neutralFillSecondaryHover: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralFillSecondaryHoverDelta: DesignToken<number>;

// @public (undocumented)
export const neutralFillSecondaryRecipe: DesignToken<InteractiveColorRecipe>;

// @public (undocumented)
export const neutralFillSecondaryRest: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralFillSecondaryRestDelta: DesignToken<number>;

// @public (undocumented)
export const neutralFillStealthActive: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralFillStealthActiveDelta: DesignToken<number>;

// @public (undocumented)
export const neutralFillStealthFocus: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralFillStealthFocusDelta: DesignToken<number>;

// @public (undocumented)
export const neutralFillStealthHover: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralFillStealthHoverDelta: DesignToken<number>;

// @public (undocumented)
export const neutralFillStealthRecipe: DesignToken<InteractiveColorRecipe>;

// @public (undocumented)
export const neutralFillStealthRest: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralFillStealthRestDelta: DesignToken<number>;

// @public (undocumented)
export const neutralFillStrongActive: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralFillStrongActiveDelta: DesignToken<number>;

// @public (undocumented)
export const neutralFillStrongFocus: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralFillStrongFocusDelta: DesignToken<number>;

// @public (undocumented)
export const neutralFillStrongHover: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralFillStrongHoverDelta: DesignToken<number>;

// @public (undocumented)
export const neutralFillStrongMinContrast: DesignToken<number>;

// @public (undocumented)
export const neutralFillStrongRecipe: DesignToken<InteractiveColorRecipe>;

// @public (undocumented)
export const neutralFillStrongRest: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralFillStrongRestDelta: DesignToken<number>;

// @public (undocumented)
export const neutralForegroundActive: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralForegroundActiveDelta: DesignToken<number>;

// @public (undocumented)
export const neutralForegroundFocus: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralForegroundFocusDelta: DesignToken<number>;

// @public (undocumented)
export const neutralForegroundHint: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralForegroundHintRecipe: DesignToken<ColorRecipe>;

// @public (undocumented)
export const neutralForegroundHover: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralForegroundHoverDelta: DesignToken<number>;

// @public (undocumented)
export const neutralForegroundMinContrast: DesignToken<number>;

// @public (undocumented)
export const neutralForegroundRecipe: DesignToken<InteractiveColorRecipe>;

// @public (undocumented)
export const neutralForegroundRest: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralForegroundRestDelta: DesignToken<number>;

// @public (undocumented)
export const neutralPalette: DesignToken<Palette<Swatch>>;

// @public (undocumented)
export const neutralStrokeActive: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralStrokeActiveDelta: DesignToken<number>;

// @public (undocumented)
export const neutralStrokeDividerRecipe: DesignToken<ColorRecipe>;

// @public (undocumented)
export const neutralStrokeDividerRest: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralStrokeDividerRestDelta: DesignToken<number>;

// @public (undocumented)
export const neutralStrokeFocus: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralStrokeFocusDelta: DesignToken<number>;

// @public (undocumented)
export const neutralStrokeHover: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralStrokeHoverDelta: DesignToken<number>;

// @public (undocumented)
export const neutralStrokeInputActive: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralStrokeInputActiveDelta: DesignToken<number>;

// @public (undocumented)
export const neutralStrokeInputFocus: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralStrokeInputFocusDelta: DesignToken<number>;

// @public (undocumented)
export const neutralStrokeInputHover: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralStrokeInputHoverDelta: DesignToken<number>;

// @public (undocumented)
export const neutralStrokeInputRecipe: DesignToken<InteractiveColorRecipe>;

// @public (undocumented)
export const neutralStrokeInputRest: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralStrokeInputRestDelta: DesignToken<number>;

// @public (undocumented)
export const neutralStrokeRecipe: DesignToken<InteractiveColorRecipe>;

// @public (undocumented)
export const neutralStrokeRest: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralStrokeRestDelta: DesignToken<number>;

// @public (undocumented)
export const neutralStrokeStrongActive: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralStrokeStrongActiveDelta: DesignToken<number>;

// @public (undocumented)
export const neutralStrokeStrongFocus: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralStrokeStrongFocusDelta: DesignToken<number>;

// @public (undocumented)
export const neutralStrokeStrongHover: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralStrokeStrongHoverDelta: DesignToken<number>;

// @public (undocumented)
export const neutralStrokeStrongMinContrast: DesignToken<number>;

// @public (undocumented)
export const neutralStrokeStrongRecipe: DesignToken<InteractiveColorRecipe>;

// @public (undocumented)
export const neutralStrokeStrongRest: CSSDesignToken<Swatch>;

// @public (undocumented)
export const neutralStrokeStrongRestDelta: DesignToken<number>;

// @public
export interface Palette<T extends Swatch = Swatch> {
    closestIndexOf(reference: RelativeLuminance): number;
    colorContrast(reference: RelativeLuminance, minContrast: number, initialIndex?: number, direction?: PaletteDirection): T;
    delta(reference: RelativeLuminance, delta: number, direction: PaletteDirection): T;
    get(index: number): T;
    readonly source: T;
    readonly swatches: ReadonlyArray<T>;
}

// @public
export type PaletteDirection = PaletteDirectionValue | (() => PaletteDirectionValue);

// @public
export const PaletteDirectionValue: Readonly<{
    readonly darker: 1;
    readonly lighter: -1;
}>;

// @public
export type PaletteDirectionValue = typeof PaletteDirectionValue[keyof typeof PaletteDirectionValue];

// @public
export class PaletteRGB extends BasePalette<SwatchRGB> {
    static from(source: SwatchRGB, options?: Partial<PaletteRGBOptions>): PaletteRGB;
}

// @public
export interface PaletteRGBOptions {
    preserveSource: boolean;
    stepContrast: number;
    stepContrastRamp: number;
}

// @public
export interface RelativeLuminance {
    readonly relativeLuminance: number;
}

// @public
export function resolvePaletteDirection(direction: PaletteDirection): PaletteDirectionValue;

// @public
export const StandardFontWeight: {
    readonly Thin: 100;
    readonly ExtraLight: 200;
    readonly Light: 300;
    readonly Normal: 400;
    readonly Medium: 500;
    readonly SemiBold: 600;
    readonly Bold: 700;
    readonly ExtraBold: 800;
    readonly Black: 900;
};

// @public (undocumented)
export const strokeWidth: CSSDesignToken<number>;

// @public
export interface Swatch extends RelativeLuminance {
    contrast(target: RelativeLuminance): number;
    toColorString(): string;
}

// @public
export class SwatchRGB implements Swatch {
    constructor(red: number, green: number, blue: number);
    readonly b: number;
    contrast: any;
    createCSS: () => string;
    static from(obj: {
        r: number;
        g: number;
        b: number;
    }): SwatchRGB;
    readonly g: number;
    readonly r: number;
    readonly relativeLuminance: number;
    toColorString(): string;
}

// @public (undocumented)
export const typeRampBase: CSSDirective;

// @public (undocumented)
export const typeRampBaseFontSize: CSSDesignToken<string>;

// @public (undocumented)
export const typeRampBaseFontVariations: CSSDesignToken<string>;

// @public (undocumented)
export const typeRampBaseLineHeight: CSSDesignToken<string>;

// @public (undocumented)
export const typeRampMinus1: CSSDirective;

// @public (undocumented)
export const typeRampMinus1FontSize: CSSDesignToken<string>;

// @public (undocumented)
export const typeRampMinus1FontVariations: CSSDesignToken<string>;

// @public (undocumented)
export const typeRampMinus1LineHeight: CSSDesignToken<string>;

// @public (undocumented)
export const typeRampMinus2: CSSDirective;

// @public (undocumented)
export const typeRampMinus2FontSize: CSSDesignToken<string>;

// @public (undocumented)
export const typeRampMinus2FontVariations: CSSDesignToken<string>;

// @public (undocumented)
export const typeRampMinus2LineHeight: CSSDesignToken<string>;

// @public (undocumented)
export const typeRampPlus1: CSSDirective;

// @public (undocumented)
export const typeRampPlus1FontSize: CSSDesignToken<string>;

// @public (undocumented)
export const typeRampPlus1FontVariations: CSSDesignToken<string>;

// @public (undocumented)
export const typeRampPlus1LineHeight: CSSDesignToken<string>;

// @public (undocumented)
export const typeRampPlus2: CSSDirective;

// @public (undocumented)
export const typeRampPlus2FontSize: CSSDesignToken<string>;

// @public (undocumented)
export const typeRampPlus2FontVariations: CSSDesignToken<string>;

// @public (undocumented)
export const typeRampPlus2LineHeight: CSSDesignToken<string>;

// @public (undocumented)
export const typeRampPlus3: CSSDirective;

// @public (undocumented)
export const typeRampPlus3FontSize: CSSDesignToken<string>;

// @public (undocumented)
export const typeRampPlus3FontVariations: CSSDesignToken<string>;

// @public (undocumented)
export const typeRampPlus3LineHeight: CSSDesignToken<string>;

// @public (undocumented)
export const typeRampPlus4: CSSDirective;

// @public (undocumented)
export const typeRampPlus4FontSize: CSSDesignToken<string>;

// @public (undocumented)
export const typeRampPlus4FontVariations: CSSDesignToken<string>;

// @public (undocumented)
export const typeRampPlus4LineHeight: CSSDesignToken<string>;

// @public (undocumented)
export const typeRampPlus5: CSSDirective;

// @public (undocumented)
export const typeRampPlus5FontSize: CSSDesignToken<string>;

// @public (undocumented)
export const typeRampPlus5FontVariations: CSSDesignToken<string>;

// @public (undocumented)
export const typeRampPlus5LineHeight: CSSDesignToken<string>;

// @public (undocumented)
export const typeRampPlus6: CSSDirective;

// @public (undocumented)
export const typeRampPlus6FontSize: CSSDesignToken<string>;

// @public (undocumented)
export const typeRampPlus6FontVariations: CSSDesignToken<string>;

// @public (undocumented)
export const typeRampPlus6LineHeight: CSSDesignToken<string>;

// @internal
export const _white: SwatchRGB;

// (No @packageDocumentation comment for this package)

```
